Last Comment Bug 35837 - should be possible to move/copy address cards to different address books
: should be possible to move/copy address cards to different address books
Status: RESOLVED FIXED
relnote-seamonkey1.1
: access, fixed-seamonkey1.1a, fixed1.8.1, verified1.8.1.3
Product: MailNews Core
Classification: Components
Component: Address Book (show other bugs)
: Trunk
: All All
: P2 enhancement with 17 votes (vote)
: ---
Assigned To: Mark Banner (:standard8)
:
Mentors:
: 56821 108437 109489 112766 124230 179916 197954 207012 217902 226940 246477 250394 272991 320985 347904 365453 (view as bug list)
Depends on: 302086 134590 152133 336241
Blocks: 42879 118769 242517 320169
  Show dependency treegraph
 
Reported: 2000-04-14 04:58 PDT by André Langhorst
Modified: 2012-09-06 09:37 PDT (History)
46 users (show)
asa: blocking1.3a-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Fix for DND Move/Copy bug (3.81 KB, patch)
2004-11-13 04:27 PST, Mark Banner (:standard8)
no flags Details | Diff | Splinter Review
Fix for DND Move/Copy bug v2 (6.95 KB, patch)
2004-12-12 13:15 PST, Mark Banner (:standard8)
no flags Details | Diff | Splinter Review
Fix for DND Move/Copy bug v3 (6.63 KB, patch)
2005-01-15 05:07 PST, Mark Banner (:standard8)
mozilla: review+
mscott: superreview-
Details | Diff | Splinter Review
Thunderbird DND Move/Copy Additional Patch (1.27 KB, patch)
2005-01-22 03:06 PST, Mark Banner (:standard8)
mozilla: review+
Details | Diff | Splinter Review
Part 1. Only allow copy from read-only directories (checked in, trun + branch). (3.15 KB, patch)
2006-05-02 12:19 PDT, Mark Banner (:standard8)
mozilla: review+
mozilla: superreview+
mscott: approval‑branch‑1.8.1+
Details | Diff | Splinter Review
Part 2. Implement the main dnd functionality properly (diff -w) (10.95 KB, patch)
2006-05-08 13:28 PDT, Mark Banner (:standard8)
neil: review+
Details | Diff | Splinter Review
Part 2. Implement the main dnd functionality properly (normal patch) (13.80 KB, patch)
2006-05-08 13:29 PDT, Mark Banner (:standard8)
no flags Details | Diff | Splinter Review
Part 2 v2. Implement the main dnd functionality properly (diff -w) (10.95 KB, patch)
2006-05-21 13:41 PDT, Mark Banner (:standard8)
standard8: review+
mozilla: superreview+
mscott: approval‑branch‑1.8.1+
Details | Diff | Splinter Review
Part 2 v2. Implement the main dnd functionality properly (normal patch, checked in trunk + branch) (13.81 KB, patch)
2006-05-21 13:42 PDT, Mark Banner (:standard8)
no flags Details | Diff | Splinter Review
patch test (26.46 KB, patch)
2012-09-06 09:37 PDT, celin sheeba
no flags Details | Diff | Splinter Review

Description André Langhorst 2000-04-14 04:58:54 PDT
It should be possible to move and copy once created addressbook cards to other
address books
Comment 1 lchiang 2000-04-14 12:21:45 PDT
esther - do we already have a bug on this?
Comment 2 hangas 2000-04-14 14:12:17 PDT
This may already exist as a feature bug.  Candice?
Comment 3 André Langhorst 2000-05-14 13:12:04 PDT
don´t know if it´s a DUP, but copying already seems to work, I´m not sure,
dragging should be equal with moving and dragging with pressend <ctrl> key
should copy entríes
Comment 4 selmer (gone) 2000-05-15 12:17:47 PDT
Target M17.
Comment 5 scottputterman 2000-06-09 18:56:48 PDT
copying already works as mentioned.  moving rest of bug to future.
Comment 6 fenella 2001-02-20 10:45:20 PST
Assign it to myself..
Comment 7 André Langhorst 2001-04-25 15:51:22 PDT
adjusting severity due to initially mixed up "enh" and [rfe]
Comment 8 scottputterman 2001-10-12 17:16:25 PDT
reassigning to cavin
Comment 9 Boris Zbarsky [:bz] 2001-11-04 10:06:53 PST
*** Bug 108437 has been marked as a duplicate of this bug. ***
Comment 10 Tuukka Tolvanen (sp3000) 2001-11-10 05:52:27 PST
*** Bug 109489 has been marked as a duplicate of this bug. ***
Comment 11 Ninoschka Baca 2001-12-16 14:32:10 PST
Trunk build 2001-12-13-03:WinMe
In the Address Book window I do not see a choice to move or copy addresses. The
Edit menu does not display move/copy and there is no contextual menu for move/copy.

Jen, The Address Book spec's Edit menu shows an Edit|Copy menu item but does not
have a Move option. Maybe the spec should be updated for accessibility reasons?
Comment 12 jglick 2001-12-17 11:10:11 PST
AB Edit menu should have:

Undo --- Ctrl+Z
Redo ---Ctrl-Y (Cmd+Shift-Z mac)
---------------------
Cut --- Ctrl+X
Copy --- Ctrl+C
Paste --- Ctrl+V
Delete --- Del
----------------------
Select All --- Ctrl+A
----------------------
<Card/Address Book/Directory> Properties... --- Ctrl+I
Preferences...

If a card is selected, users should be able to select the menu items to Copy and 
Paste an AB entry from one AB to another.

A DnD from a Local AB to another is a move. A Ctrl+DnD is a Copy. A DnD or 
Ctrl+DnD from an LDAP Dir to a Local AB is always a Copy since a Move is not 
allowed. A DnD from a Local AB to an LDAP Dir is not allowed.
Comment 13 Ninoschka Baca 2001-12-18 09:47:37 PST
Marking nsbeta1 for accessbility reasons so that there is a copy menu item.
Currently you have to use the mouse to d&d to copy a card/list.
Comment 14 Jaime Rodriguez, Jr. 2002-01-18 08:56:51 PST
Is this really a nsbeta1+, P2? If yes, then we need to try and schedule it for
the MachV release.
Comment 15 Srilatha Moturi 2002-02-12 11:27:57 PST
*** Bug 124230 has been marked as a duplicate of this bug. ***
Comment 16 John Levon 2002-06-02 17:18:45 PDT
*** Bug 112766 has been marked as a duplicate of this bug. ***
Comment 17 Derek Lee 2002-06-25 14:29:06 PDT
A remark on comment #13

I can drag and drop cards, but I cannot drag and drop lists.
To be more precise, when I d&d a list, the copy at its destination is an empty
card (even though the destination address book contains the emails listed in the
list.)

Moz 1.0 release and 1.1a (2002061504) for i686 Linux
Comment 18 Derek Lee 2002-07-08 08:46:56 PDT
I have just noticed that my problem in comment 17 is mentioned in
comment 3 of Bug 41590 (dated 6/6/2000!)

Comment 19 Ninoschka Baca 2002-08-31 21:26:12 PDT
Marking nsbeta1. There should be an Edit|Copy and an Edit|Move menu option for
accessibility reasons.
Comment 20 Brant Gurganus 2002-10-13 11:14:35 PDT
[RFE] is deprecated in favor of severity: enhancement.  They have the same meaning.
Comment 21 Dave Evans 2002-10-15 07:55:32 PDT
> A DnD from a Local AB to another is a move. A Ctrl+DnD is a Copy.

Actually, (for me at least) they're both a Copy.  The mouse pointer changes as
appropriate (the presence/absence of the "+" part next to the arrow), but they
both end up doing a Copy nevertheless.

Comment 22 R.K.Aa. 2002-11-13 07:55:21 PST
*** Bug 179916 has been marked as a duplicate of this bug. ***
Comment 23 Mike Fedyk 2002-12-04 13:50:00 PST
We should do what is said in comment 12, and I can still reproduce comment 21 in
build 20021126 on win32 and linux build 20021128

Also bug 56821 insn't an entire dup, but once this bug is fixed 56821 is fixed
too at the same time.
Comment 24 Mark 2002-12-12 01:05:11 PST
(On Windows 2000 moz 1.2.1)  I just tried to cut all my cards from the collected
address book and paste to another address book.  Then I tried dragging.  Since
the old ones did not go away in either case, I assumed it didnt work, and didnt
even look in the new address book.  The fact that the Edit/Cut+Past+Copy menu
items are greyed out doesnt help this impression any either.  I know this is a
bit repetitive, but this is horribly un-intuitive behavior, certainly a more
severe user interface issue than just an enhancement.  If I hadnt looked thru
bugzilla, I would have given up.

I would add a request that the cut operation should be made to work either by
greying out the cut cards until they are pasted (as when moving files in
Explorer) or simply by having the cards disappear after cutting.  A move, but in
two steps, just like every other Windows app allows.
Comment 25 Ninoschka Baca 2002-12-26 17:55:23 PST
*** Bug 56821 has been marked as a duplicate of this bug. ***
Comment 26 Bas Cancrinus 2003-03-01 17:20:24 PST
Edit->Undo,Redo,Cut,Copy,Paste still disabled in Moz1.3b@Win32.
I disagree with the 'enhancement' severity of this bug.
Comment 27 arnova 2003-06-02 02:00:13 PDT
I agree on the fact that this isn't just an enhanced. Its a severe bug and it
has been in there for simply too long now. Without these options its almost
impossible to properly manage ones address-book. I don't know what the
target-milestone is but I suggest it should be 1.5alpha.
Comment 28 Jim Booth 2003-06-15 13:56:31 PDT
Note that when dragging a card to another address book, if you press CTRL, the
"+" icon appears next to the mouse pointer indicating copy.  This would suggest
that without the CTRL, one would expect MOVE, but that copies too.  From Windows
conventions, you might expect SHIFT+DRAG to be MOVE, but that also does a COPY.
 Seems like the code is half there since CTRL pops up the + icon, just need to
make the default behavior be to MOVE.
Comment 29 Jim Booth 2003-06-15 15:19:07 PDT
*** Bug 197954 has been marked as a duplicate of this bug. ***
Comment 30 Jim Booth 2003-06-15 15:21:44 PDT
*** Bug 207012 has been marked as a duplicate of this bug. ***
Comment 31 Jo Hermans 2003-08-31 14:01:04 PDT
*** Bug 217902 has been marked as a duplicate of this bug. ***
Comment 32 Joe Infla 2003-12-29 10:44:01 PST
*** Bug 226940 has been marked as a duplicate of this bug. ***
Comment 33 Mark Stier 2004-01-27 01:45:52 PST
Having a right-click-option to send a contact card via email would be great,
too. Or even better: drag contact card on another to do that! (open new message
to that one and inserting it)
Comment 34 Thomas Brown 2004-02-04 08:56:26 PST
Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7a) Gecko/20040202

Curious about status as this one is rather old and the bug in comment #21 still
exists (moving or copying address book entries *always copies* even though icon
appropriately changes between move and copy upon holding down Ctrl key while
dragging).
Comment 35 Stefan Borggraefe 2004-06-12 06:22:02 PDT
*** Bug 246477 has been marked as a duplicate of this bug. ***
Comment 36 R.K.Aa. 2004-07-16 08:31:37 PDT
*** Bug 251681 has been marked as a duplicate of this bug. ***
Comment 37 seth wandersman 2004-07-17 14:21:50 PDT
I have been waiting release after a release for a fix for this bug. Because of
this I don't have any control over my adress books, they are just various
jumbles of duplicated adresses.
Comment 38 Wayne Mery (:wsmwk, NI for questions) 2004-07-17 17:19:50 PDT
seems like it should be a trivial fix -:)
Comment 39 Mark Banner (:standard8) 2004-11-13 04:27:06 PST
Created attachment 165788 [details] [diff] [review]
Fix for DND Move/Copy bug

This patch provides a fix to allow the move/copy functions to work properly
when using drag and drop for cards.
Comment 40 Mark Banner (:standard8) 2004-11-13 05:02:09 PST
Comment on attachment 165788 [details] [diff] [review]
Fix for DND Move/Copy bug

Sorry for the spam, cancelling review as this patch may give us more problems
as it breaks dnd to a list (you can't move a card to a list - only copy it)
Comment 41 Mark Banner (:standard8) 2004-12-12 13:15:13 PST
Created attachment 168563 [details] [diff] [review]
Fix for DND Move/Copy bug v2

This patch provides a better fix for DND Move/Copy. It deals with the issue of
moving mail lists correct (copy not allowed as that = duplicates) as well as
the copying/moving of cards.

Note that when dragging to a mail list, the action is forced to be a copy as a)
the cards would be lost if it is a move, as they should exist in a directory,
and b) the default drag action is move, so it'd be a bit annoying if we
prompted the user all the time.

Mailing List drag and drop is actually bug 42879 and part of this patch was
taken from the old patch on that bug by Sean Gao.
Comment 42 Doug Wright 2005-01-10 09:23:48 PST
*** Bug 272991 has been marked as a duplicate of this bug. ***
Comment 43 Mark Banner (:standard8) 2005-01-15 04:52:29 PST
Comment on attachment 168563 [details] [diff] [review]
Fix for DND Move/Copy bug v2

Due to other changes this patch now bitrots. Going to add an updated version.
Comment 44 Mark Banner (:standard8) 2005-01-15 05:07:50 PST
Created attachment 171343 [details] [diff] [review]
Fix for DND Move/Copy bug v3

Revised version that fixes bitrot - still only will fix the dnd in address
book, not the copy & paste menu items.
Comment 45 Mark Banner (:standard8) 2005-01-22 03:06:02 PST
Created attachment 172084 [details] [diff] [review]
Thunderbird DND Move/Copy Additional Patch

This is an additional patch that we need to stop thunderbird breaking. It just
applies the same changes to the thunderbird addressbook.properties as the Fix
DND Move/Copy v3 patch does to mailnews.

These patches will need to be applied to the tree together.
Comment 46 Mark Banner (:standard8) 2005-01-30 09:16:26 PST
Scott any chance of an sr of this dnd fix(es) for address book before 1.8b
branch? I don't think it can be classed as a release blocker, but it's a long
awaited fix for both mailnews and thunderbird that would be good to get in.
Comment 47 Scott MacGregor 2005-01-31 14:09:07 PST
Comment on attachment 171343 [details] [diff] [review]
Fix for DND Move/Copy bug v3

A drop operation should never result in a prompt after the drop.

The code should just not allow the drop if the selection contains a mailing
list. 

I'd suggest modifing the method for reporting if a drag is enabled to say no 
if the drag items include a mailing list. 

Then remove all the code and the string bundle change for the prompt that got
added. Otherwise the code looked good.
Comment 48 Mark Banner (:standard8) 2005-02-01 00:36:02 PST
Comment on attachment 172084 [details] [diff] [review]
Thunderbird DND Move/Copy Additional Patch

Clearing extra request, as I'll be wrapping the two patches into one with
scott's latest comments.
Comment 49 Mark Banner (:standard8) 2005-02-07 13:01:05 PST
On reassessing this bug, found two others that I think really should be fixed
before finishing this one. Adding dependencies.
Comment 50 Peter Kupfer 2005-02-26 11:40:10 PST
Still present in TB 1.0 build 20041206 for what it is worth.
Comment 51 Peter Kupfer 2005-02-26 11:43:02 PST
Sorry for the second message to anyone that is cced, but I do not know what to
do with the attached patch. I went to download it and I don't really know how to
install it. Is there a help section about installing patched somewhere or can
some one explain it to me.

Thanks.
Comment 52 Mark Banner (:standard8) 2005-08-17 13:25:59 PDT
*** Bug 250394 has been marked as a duplicate of this bug. ***
Comment 53 Mark Banner (:standard8) 2005-12-20 12:33:53 PST
*** Bug 320985 has been marked as a duplicate of this bug. ***
Comment 54 Mark Banner (:standard8) 2006-05-02 12:19:32 PDT
Created attachment 220535 [details] [diff] [review]
Part 1. Only allow copy from read-only directories (checked in, trun + branch).

This patch will change the UI so that only copying is allowed from read-only (e.g. ldap) directories, and only copying or moving are allowed from read-write directories. This is the first part of a series of dnd patches.

It really needs bug 336241 (check if drop is allowed when modifier keys change) fixing before it can go into a proper release, however I don't see a problem with fixing it on trunk in the meantime.
Comment 55 David :Bienvenu 2006-05-02 13:10:23 PDT
Comment on attachment 220535 [details] [diff] [review]
Part 1. Only allow copy from read-only directories (checked in, trun + branch).

thx, Mark.
Comment 56 Mark Banner (:standard8) 2006-05-08 13:28:46 PDT
Created attachment 221344 [details] [diff] [review]
Part 2. Implement the main dnd functionality properly (diff -w)

I think this is now ready for review. I've done various testing on the items mentioned in the comments for canDrop and I think it is all at least behaving sensibly, but its also time to get some more eyes on it.

The only thing I would like to be able to do is default to copy when dragging, however I can't find a way to do that at the moment, so I'm going to follow it up on the newsgroups. However, this patch still improves the current situation a lot.

The non diff -w version is coming up in a moment.
Comment 57 Mark Banner (:standard8) 2006-05-08 13:29:47 PDT
Created attachment 221345 [details] [diff] [review]
Part 2. Implement the main dnd functionality properly (normal patch)
Comment 58 Steve VanSlyck 2006-05-08 14:07:31 PDT
I think we should default to move when dragging. After all the whole point is to have only one entry per person/email address/whatever.
Comment 59 neil@parkwaycc.co.uk 2006-05-19 13:58:59 PDT
Comment on attachment 221344 [details] [diff] [review]
Part 2. Implement the main dnd functionality properly (diff -w)

>+      if (selectedRows == "")
Nit: if (!selectedRows)

>+    if (srcURI.split(targetURI) != srcURI)
That's probably the wrong test, since what you really want to know is if the targetURI begins with srcURI.

>+      if (dataObj)
>+        dataObj = dataObj.value.QueryInterface(Components.interfaces.nsISupportsString);
>+      else
>+        continue;
Nit: if (!dataObj) and no else. Or possibly if (!(dataObj instanceof ...))
Comment 60 Mark Banner (:standard8) 2006-05-19 14:08:16 PDT
Comment on attachment 220535 [details] [diff] [review]
Part 1. Only allow copy from read-only directories (checked in, trun + branch).

Requesting 1.8 approval on the first part of this dnd patch. It's been on trunk for a while now and will go in at the same time as the already approved patch on bug 336241.
Comment 61 Mark Banner (:standard8) 2006-05-21 13:41:38 PDT
Created attachment 222803 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (diff -w)

Updated patch to address Neil's comment, carrying forward his r+, requesting sr
Comment 62 Mark Banner (:standard8) 2006-05-21 13:42:34 PDT
Created attachment 222804 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (normal patch, checked in trunk + branch)

Normal version of Part 2 v2
Comment 63 Mark Banner (:standard8) 2006-05-21 13:43:53 PDT
Comment on attachment 221345 [details] [diff] [review]
Part 2. Implement the main dnd functionality properly (normal patch)

Sorry for spam, obsolete the correct patch...
Comment 64 Mark Banner (:standard8) 2006-05-21 13:44:54 PDT
Comment on attachment 222803 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (diff -w)

...re-requesting superreview on the correct patch.
Comment 65 Mark Banner (:standard8) 2006-05-22 10:24:36 PDT
Comment on attachment 222804 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (normal patch, checked in trunk + branch)

Checked in on trunk. I'll leave it there for a few days, and then request branch approval, should be in time for SeaMonkey 1.1a/Thunderbird 2.0a
Comment 66 Mark Banner (:standard8) 2006-05-22 11:02:29 PDT
Marking as fixed. I'll request branch approval in a few days once its had time to soak on trunk.
Comment 67 Mark Banner (:standard8) 2006-05-25 14:29:11 PDT
Comment on attachment 222803 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (diff -w)

How about getting this in in time for Thunderbird 2.0a/SeaMonkey 1.1a when the branch reopens?

Implements much better drag and drop functionality in address book.
Comment 68 Scott MacGregor 2006-05-25 14:31:25 PDT
Comment on attachment 222803 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (diff -w)

sounds good to me. The branch is closed for anything that effects Firefox. mail changes are still fine.
Comment 69 Mark Banner (:standard8) 2006-05-27 01:00:22 PDT
Comment on attachment 222804 [details] [diff] [review]
Part 2 v2. Implement the main dnd functionality properly (normal patch, checked in trunk + branch)

Part 2 also checked into the branch.
Comment 70 James Teh [:Jamie] 2006-05-28 16:11:39 PDT
I assume this only fixes drag and drop and not moving/copying and pasting using the edit menu/keyboard? I filed Bug 339227 only a few days ago, which concerns the latter case. If it does fix edit menu copy/cut/paste (I have checked Thunderbird 2alpha1 20060527 and it does not appear to fix this), then Bug 339227 is a duplicate with apologies.
Comment 71 Mark Banner (:standard8) 2006-08-08 11:02:30 PDT
*** Bug 347904 has been marked as a duplicate of this bug. ***
Comment 72 Mark Banner (:standard8) 2006-12-31 04:58:29 PST
*** Bug 365453 has been marked as a duplicate of this bug. ***
Comment 73 Mark Banner (:standard8) 2007-01-16 11:45:28 PST
I think this needs a relnote for the SeaMonkey 1.1 release at least, something along the lines of:

It is now possible to move or copy cards between address books.

Cards can only be copied to mailing lists, so you need to use ctrl key whilst dragging to copy the card to the mailing list.

When dragging cards between address books, the default action is move,
use ctrl to copy instead.
Comment 74 Carsten Book [:Tomcat] 2007-04-05 11:40:33 PDT
verified fixed 1.8.1.3 Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US; rv:1.8.1.3) Gecko/20070326 Thunderbird/2.0.0.0 Mnenhy/0.7.5.0 ID:2007032620
Comment 75 celin sheeba 2012-09-06 09:37:42 PDT
Created attachment 658908 [details] [diff] [review]
patch test

Note You need to log in before you can comment on or make changes to this bug.